#ifndef ERROR_HANDLER_H
#define ERROR_HANDLER_H

#include "../share/common.h"

// Prototype declaration(s)
class ErrorHandler;


// Define global function(s) for binary operators
ostream& operator<<(ostream&  os, const ErrorHandler& e);
ostream& operator<<(ofstream& os, const ErrorHandler& e);


// Definition(s) of interface class(es)
class ErrorHandler
{
public:
	virtual string message() const = 0;
	virtual ~ErrorHandler(){}
};




// Definition(s) of concrete class(es)

class ErrorBuilding_scan : public ErrorHandler
{
	string str;
public:
	ErrorBuilding_scan(string str_){str = str_;}
	virtual string message() const;
};

class Error_main : public ErrorHandler
{
	int  total;
	int  delim;
	int  steps;
	bool incrm;
public:
	Error_main(int total_, int delim_, int steps_, bool incrm_ = false)
	{
		total = total_;
		delim = delim_;
		steps = steps_;
		incrm = incrm_;
	}
	virtual string message() const;
};

class ErrorDroplet_scan : public ErrorHandler
{
	string str;
public:
	ErrorDroplet_scan(string str_){str = str_;}
	virtual string message() const;
};

class ErrorPointDropletSrc_scan : public ErrorHandler
{
	string str;
public:
	ErrorPointDropletSrc_scan(string str_){str = str_;}
	virtual string message() const;
};

class ErrorPointSrc_scan : public ErrorHandler
{
	string str;
public:
	ErrorPointSrc_scan(string str_){str = str_;}
	virtual string message() const;
};

#endif
