#include "MyConvexHull.h"

MyConvexHull::MyConvexHull(Vector2d* pts_, int nr_p_, Method method)
{
	ML_TRACE("MyConvexHull::MyConvexHull");

	pts  = pts_;
	nr_p = nr_p_;


	const bool alg = (method == INCREMENTAL);

	ConvexHull2d* hll = new ConvexHull2d(nr_p, pts, alg);
	nr_v = hll->GetQuantity();

	const int* idx = hll->GetIndices();
	Vector2d* buf = new Vector2d[nr_v];

	for(int i = 1; i <= getNoVerteces(); i++)
		buf[i-1] = pts[idx[i-1]];

	for(int j = 1; j <= getNoVerteces(); j++)
	{
		// CLOG << buf[j-1].X() << ',' << buf[j-1].Y() << ',';
		pts[j-1] = buf[j-1];
	}
	// CLOG << endl;

	delete [] buf;
	delete hll;
}

double MyConvexHull::getConvexHullArea() const
{
	ML_TRACE("MyConvexHull::getConvexHullArea");

	double area = (pt(getNoVerteces()).Y() + pt(1).Y())*(pt(getNoVerteces()).X() - pt(1).X())*0.5;

	for(int i = 1; i < getNoVerteces(); i++)
	{
		area += (pt(i).Y() + pt(i + 1).Y())*(pt(i).X() - pt(i + 1).X())*0.5;
	}

	return fabs(area);
}
