#include "version.h"
#include "BuildingParameters.h"
#include "ErrorHandler.h"
#include "../simulator/PointDropletSrc.h"

// Construct the log & err global file streams ...
ofstream CLOG("../tmp/building_log.txt", ios::out);
ofstream CERR("../tmp/building_err.txt", ios::out);
ofstream CLST("../tmp/building_lst.txt", ios::out);

bool TRACE_Q = false;

int main(int argc, char* argv[])
{
	clog << VERSION1 << endl;
	CLOG << VERSION1 << endl;
	CLST << VERSION2 << endl;

	Building* blg = new Building();
	blg->scan();
	blg->lists();
	blg->prep();

	BuildingParameters* prm = new BuildingParameters(blg);

	Droplet* drp = new Droplet();
	drp->scan();

	PointDropletSrc* pts = new PointDropletSrc(drp);
	pts->scan();
	prm->setPointSrc(pts);
	prm->open();


	int steps = 0;
	for(int i = 1; i <= pts->getNoElms(); i++)
	{
		prm->exec(); pts->advance(); steps++;
		clog << Error_main(pts->getNoElms(), 10, steps, false);
		CLOG << Error_main(pts->getNoElms(), 10, steps,  true);
	}

	prm->close();

	delete pts;
	delete drp;
	delete prm;
	delete blg;

	return 0;
}
