#ifndef STABILITY_H
#define STABILITY_H

#include "MetData.h"
#include "sun.h"
#include "../share/TimeCode.h"

class Stability : public FileManager
{
protected:
	double lon;		// Longitude
	double lat;		// Latitude
	double zzz;		// Height of anemometer (meters)

	Sun*      sun;
	MetData*  met;
	TimeCode* tim;
protected:
	virtual int table(Sun::SunPosition sp, double dl, double ws, double ave, double sn) const;
public:
	Stability()
	{
		setOsFile(FileList::fnStability(FileList::OS, 1));
	}

	virtual void scan ();
	virtual void print() const;
	virtual void run  ();

	virtual ~Stability();
};

#endif
