#ifndef STATISTICS_H
#define STATISTICS_H

#include "../share/common.h"

class Statistics
{
	int nr_dy_codes; int nr_dy_codes_p;
	int nr_hr_codes; int nr_hr_codes_p;
	int nr_wd_codes;
	int nr_st_codes;
protected:
	double* windspeed;
	int*    accepted_wind_counter;
	int*    rejected_wind_counter;
	int*    accepted_stab_counter;
	int*    rejected_stab_counter;

	// Code Definitions:
	// 1=NNE, 2=NE,..., 15=NNE, 16=N, 17=CALM, 9999=N/A
	virtual int getWindDirectionCode(double wd) const;

	virtual string wdsymbol(int wd) const;
	virtual string stsymbol(int st) const;
public:
	Statistics(int nr_dy_codes_, int nr_hr_code_);
	virtual void reset ();
	virtual void add   (int dy, int hr, double wd, double ws, int st);
	virtual void dump  () const;
	virtual ~Statistics();
};

#endif
