#ifndef SUN2_H
#define SUN2_H

#include "sun.h"

class Sun2 : public Sun
{
	int timezone;
protected:
	int     getTimeZone() const {return timezone;}
	virtual double hourAngle() const;
	virtual void   evalSunRiseSunSet(double& sr, double& ss) const;
	virtual double modulo(double val, int div) const
	{
		const int    in = floor(val);
		const double fl = val - in;
		const int    Q  = in % div;
		return Q + fl;
	}
public:
	Sun2(double lon_, double lat_, int timezone_) : Sun(lon_, lat_) {timezone = timezone_;}
	virtual SunPosition getSunPosition(double& sr, double& ss) const;

	virtual ~Sun2(){}
};

#endif SUN2_H
