#include "kalendar.h"

int Kalendar::julian() const
{
	int jul;
	int ja,jy=yr,jm;
	
	if (jy < 0) ++jy;
	if (mn > 2)
	{
		jm=mn+1;
	}
	else
	{
		--jy;
		jm=mn+13;
	}
	jul = (int) (floor(365.25*jy)+floor(30.6001*jm)+dy+1720995);
	if (dy+31L*(mn+12L*yr) >= 15+31L*(10+12L*1582))
	{
		ja=(int)(0.01*jy);
		jul += 2-ja+(int) (0.25*ja);
	}
	return jul;
}

int Kalendar::daysOfMonth() const
{
	int days[12];
	days[0] = days[2] = days[4] = days[6] = days[7] = days[9] = days[11] = 31;
	days[3] = days[5] = days[8] = days[10]                               = 30;
	days[1]                                                              = 28;
	
	int nr_days = days[mn - 1];
	if(leapYear() && mn == 2)
		nr_days++;
	
	return nr_days;
}

int Kalendar::daysFromThisYear()
{
	const int cur = julian();
	
	const int _yr = yr;
	const int _mn = mn;
	const int _dy = dy;
	
	setDate(_yr, 1, 1);
	const int d_0 = julian();
	setDate(_yr, _mn, _dy);
	
	return cur - d_0;	
}
