#include "ErrorHandler.h"
#include "simulator.h"


ostream& operator<<(ostream&  os, const ErrorHandler& e)
{
	return os << e.message();
}

ostream& operator<<(ofstream& os, const ErrorHandler& e)
{
	return os << e.message();
}



/*
*
*     Implementation(s) of concrete class(es)
*
*/

string ErrorMetData_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program MetData::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorTimeCode_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program TimeCode::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorBlg_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Blg::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorDroplet_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Droplet::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorLineSrc_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program LineSrc::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPasquillGifford_szSolve::message() const
{
	message_counter_ErrorPasquillGifford_szSolve++;

	string msg = "";

	if(message_counter_ErrorPasquillGifford_szSolve <= MAX_WARNING_MESSAGE)
	{
		char buffer[50];
		_gcvt(rhs, 8, buffer); string str_rhs = buffer;
		_gcvt(sol, 8, buffer); string str_sol = buffer;

		msg  = "+WARNING MESSAGE\n";
		msg += " - Convergence process could not be finished within the given maximum iteration.\n";
		msg += " - Warning occurs in program PasquillGifford::szSolve.\n";
		msg += "+STATUS\n";
		msg += " - Given equation is sz(x) = " + str_rhs + ". " + "Software's answer is " + str_sol + ".\n";
		msg += "+RESOLUTIONS\n";
		msg += " - This program gives the virtual point source distance using ISC3 scheme.\n";
		msg += " - You may need to hack the source code for resolving convergence problem.\n";
		msg += "...Process continued ...\n\n";
	}

	if(message_counter_ErrorPasquillGifford_szSolve == MAX_WARNING_MESSAGE)
	{
		msg += "Further warning messages will be suppressed ...\n";
	}

	return msg;
}

string ErrorPasquillGifford_getPrm_z::message() const
{
	char buffer[8]; _itoa(st, buffer, 10); string str_stb = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Invalid the stability code " + str_stb + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PasquillGifford::getPrm_z. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the illegal stability code assignment.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate code.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPasquillGifford_getPrm_y::message() const
{
	char buffer[8]; _itoa(st, buffer, 10); string str_stb = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Invalid the stability code " + str_stb + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PasquillGifford::getPrm_y. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the illegal stability code assignment.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate code.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPasquillGifford_getPrm_sySolve::message() const
{
	char buffer[8]; _itoa(st, buffer, 10); string str_stb = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Invalid the stability code " + str_stb + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PasquillGifford::getPrm_sySolve. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the illegal stability code assignment.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate code.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPasquillGifford_getTurners::message() const
{
	char buffer[8]; _itoa(st, buffer, 10); string str_stb = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Invalid the stability code " + str_stb + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PasquillGifford::getTurners. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the illegal stability code assignment.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate code.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorMain_argc::message() const
{
	char buffer[8]; _itoa(nr, buffer, 10); string str_nr = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Too many or less command line options. " + str_nr + " options detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program main. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - Usage:: simulator -[t][s] [mt][ln]\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorMain_argfile::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program main. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorMain_argv::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Unrecognized command line argument(s) detected (" + op1 + " & " + op2 + ").\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program main. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - Usage:: simulator -[t][s] [mt][ln]\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorMet_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Met::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorMetTimeSeries_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program MetTimeSeries::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_gser_1::message() const
{
	char buffer[50];
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Illegal argument x = " + str_x + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::gser. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates incomplete gamma function with series expansion.\n";
	msg += " - Evaluated incomplete gamma function is defined as the following:\n";
	msg += " - P[a,x] := Integrate[Exp[-t]*Power[t,a-1],{t,0,x}]/Gamma[a] s.t. a,x > 0.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_gser_2::message() const
{
	char buffer[50];
	_gcvt(a, 8,  buffer); string str_a = buffer;
	_itoa(i, buffer, 10); string str_i = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Too large argument a = " + str_a + " and too small ITMAX = " + str_i + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::gser. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates incomplete gamma function with series expansion.\n";
	msg += " - Evaluated incomplete gamma function is defined as the following:\n";
	msg += " - P[a,x] := Integrate[Exp[-t]*Power[t,a-1],{t,0,x}]/Gamma[a] s.t. a,x > 0.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_gcf::message() const
{
	char buffer[50];
	_gcvt(a, 8,  buffer); string str_a = buffer;
	_itoa(i, buffer, 10); string str_i = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Too large argument a = " + str_a + " and too small ITMAX = " + str_i + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::gcf. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates incomplete gamma function with series expansion.\n";
	msg += " - Evaluated incomplete gamma function is defined as the following:\n";
	msg += " - Q[a,x] := Integrate[Exp[-t]*Power[t,a-1],{t,x,Infinity}]/Gamma[a] s.t. a,x > 0.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_gammp::message() const
{
	char buffer[50];
	_gcvt(a, 8, buffer); string str_a = buffer;
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Illegal argument(s) detected ( a = " +  str_a + " : x = " + str_x + " ).\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::gammp. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates incomplete gamma function.\n";
	msg += " - Evaluated incomplete gamma function is defined as the following:\n";
	msg += " - P[a,x] := Integrate[Exp[-t]*Power[t,a-1],{t,0,x}]/Gamma[a] s.t. a,x > 0.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_gammq::message() const
{
	char buffer[50];
	_gcvt(a, 8, buffer); string str_a = buffer;
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Illegal argument(s) detected ( a = " +  str_a + " : x = " + str_x + " ).\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::gammp. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates incomplete gamma function.\n";
	msg += " - Evaluated incomplete gamma function is defined as the following:\n";
	msg += " - Q[a,x] := Integrate[Exp[-t]*Power[t,a-1],{t,x,Infinity}]/Gamma[a] s.t. a,x > 0.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_chebev::message() const
{
	char buffer[50];
	_gcvt(a, 8, buffer); string str_a = buffer;
	_gcvt(b, 8, buffer); string str_b = buffer;
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Illegal argument(s) detected ( a = " +  str_a + " : b = " + str_b + " : x = " + str_x + " ).\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::chebev. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates Chebyshev polynomial defined in [a,b].\n";
	msg += " - Definition of Chebushev polynomial in above interval is as the below:\n";
	msg += " - Chev[a,b : x] := Cos[n ArcCos[y]]. y := (x - 0.5*(b + a))/(0.5*(b - a)).\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_bessik_1::message() const
{
	char buffer[50];
	_gcvt(n, 8, buffer); string str_n = buffer;
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Illegal argument(s) detected ( n = " +  str_n + " : x = " + str_x + " ).\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::bessik. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates two independent modified Bessel function values.\n";
	msg += " - Modified Bessel function is defined as the following (n > 0, x > 0) :\n";
	msg += " - I[n,x] := Power[-Sqrt[-1], n]*J[n, Sqrt[-1]*x].\n";
	msg += " - K[n,x] := 0.5*Pi*Power[-Sqrt[-1], n+1]*(J[n, Sqrt[-1]*x] + Sqrt[-1]*Y[n, Sqrt[-1]*x]).\n";
	msg += " - J[n,x],Y[n,x] ... Bessel functions.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_bessik_2::message() const
{
	char buffer[50];
	_gcvt(x, 8, buffer); string str_x = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Argument x = " + str_x  + " is too large. Recommended to try asymptotic expansion.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::bessik. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates two independent modified Bessel function values.\n";
	msg += " - Modified Bessel function is defined as the following (n > 0, x > 0) :\n";
	msg += " - I[n,x] := Power[-Sqrt[-1], n]*J[n, Sqrt[-1]*x].\n";
	msg += " - K[n,x] := 0.5*Pi*Power[-Sqrt[-1], n+1]*(J[n, Sqrt[-1]*x] + Sqrt[-1]*Y[n, Sqrt[-1]*x]).\n";
	msg += " - J[n,x],Y[n,x] ... Bessel functions.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_bessik_3::message() const
{
	char buffer[50];
	_itoa(i, buffer, 10); string str_i = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Convergence process could not be finished within " + str_i + " steps.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::bessik. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates two independent modified Bessel function values.\n";
	msg += " - Modified Bessel function is defined as the following (n > 0, x > 0) :\n";
	msg += " - I[n,x] := Power[-Sqrt[-1], n]*J[n, Sqrt[-1]*x].\n";
	msg += " - K[n,x] := 0.5*Pi*Power[-Sqrt[-1], n+1]*(J[n, Sqrt[-1]*x] + Sqrt[-1]*Y[n, Sqrt[-1]*x]).\n";
	msg += " - J[n,x],Y[n,x] ... Bessel functions.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorNR_bessik_4::message() const
{
	char buffer[50];
	_itoa(i, buffer, 10); string str_i = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Convergence process could not be finished within " + str_i + " steps.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program NR::SepecialFunctions::bessik. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - The progam evaluates two independent modified Bessel function values.\n";
	msg += " - Modified Bessel function is defined as the following (n > 0, x > 0) :\n";
	msg += " - I[n,x] := Power[-Sqrt[-1], n]*J[n, Sqrt[-1]*x].\n";
	msg += " - K[n,x] := 0.5*Pi*Power[-Sqrt[-1], n+1]*(J[n, Sqrt[-1]*x] + Sqrt[-1]*Y[n, Sqrt[-1]*x]).\n";
	msg += " - J[n,x],Y[n,x] ... Bessel functions.\n";
	msg += " - Software implemented with Numerical Recipies(C).\n";
	msg += " - Please refer Numerical Recipes in C about other technical details.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPat_open::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Pat::open. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPat_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Pat::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPointDropletSrc_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PointDropletSrc::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorPointSrc_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program PointSrc::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorRan_open::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Ran::open. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorRan_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Ran::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorRcp_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Rcp::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorSimulationFactory_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Unrecognized class " + str + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program SimulationFactory::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - Probably you attempt to create your own class but the framework could not found\n";
	msg += " - such a class name in the scope. Please check the customized class spell.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorSimulator_scan::message() const
{
	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Operation failed during opening file " + str + ".\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Simulator::scan. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - This error may be caused by the incorrect file format.\n";
	msg += " - Please follow the user's manual instruction and correct to the appropriate format.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorSimulationFactory_loop::message() const
{

	string msg = "";
	const int cur = floor(((double) steps)/((double) total)*100 + 0.5);


	next_output_progress_percentages = max(next_output_progress_percentages, delim);

	if(false){/* dummy */}
	else if(cur >= next_output_progress_percentages)
	{
		char buffer[50]; _itoa(next_output_progress_percentages, buffer, 10);
		string str_next_output_progress_percentages = buffer;

		if(false){/* dummy */}
		if(next_output_progress_percentages <   10)
		{
			msg += " ... Progress   " + str_next_output_progress_percentages + " % is completed ...\n";
		}
		if(next_output_progress_percentages <  100)
		{
			msg += " ... Progress  "  + str_next_output_progress_percentages + " % is completed ...\n";
		}
		if(next_output_progress_percentages == 100)
		{
			msg += " ... Progress "   + str_next_output_progress_percentages + " % is completed ...\n\n";
			msg += "     Evaluation done! Executing postprocessing. Please wait ...\n\n";
		}

		next_output_progress_percentages = next_output_progress_percentages + (incrm ? delim : 0);
	}
	else if(steps == 1)
	{
		msg += " >>> All the warning level message will be dumped in ../tmp/simulator_log.txt. \n";
		msg += " >>> Strongly recommended to refer the log file for good understanding.\n\n";
		msg += "     Entering the evaluation loop. Please be patient for a while ...\n\n";
	}

	return msg;
}

string ErrorSimulator_power4ws::message() const
{
	char buffer[50];
	_itoa(i, buffer, 10); string str_i = buffer;

	string msg = "";
	msg += "+DIAGNOSTIC\n";
	msg += " - Invalid stability code " + str_i + " detected.\n";
	msg += "+RESULTS\n";
	msg += " - Severe error occurs in program Simulator::power4ws. Process aborted.\n";
	msg += "+SUGGESTIONS\n";
	msg += " - Acceptable stability codes are 1,2,3,4,5,6. These indicate A,B,C,D,E,F respectively.\n";
	msg += " - Related program : Simulator::reclassST.\n";
	msg += "+BUG REPORTS\n";
	msg += " - e-mail : ono@jemai.or.jp\n\n";

	return msg;
}

string ErrorSimpson::message() const
{
	if(icr) message_counter_ErrorSimpson++;

	string msg = "";

	if(message_counter_ErrorSimpson <= MAX_WARNING_MESSAGE)
	{
		// Retrieving input data
		double xxx,yyy,zzz,hhh; double wdr,wsp,tpr; int stb; dat->ptr_rcp->getCoor(xxx,yyy,zzz,hhh); dat->ptr_met->getMet(wdr,wsp,stb,tpr); wdr = dat->ptr_met->wdConverter(wdr);
		const double Tol = dat->getToleranceRatio();

		char buffer[50];
		_gcvt(tol, 8,  buffer); string str_tol = buffer;
		_gcvt(Tol, 8,  buffer); string str_Tol = buffer;
		_gcvt(xxx, 8,  buffer); string str_xxx = buffer;
		_gcvt(yyy, 8,  buffer); string str_yyy = buffer;
		_gcvt(zzz, 8,  buffer); string str_zzz = buffer;
		_gcvt(wdr, 8,  buffer); string str_wdr = buffer;
		_gcvt(wsp, 8,  buffer); string str_wsp = buffer;
		_itoa(stb, buffer, 10); string str_stb = buffer;

		msg += "\n";
		msg += "+WARNING MESSAGE\n";
		msg += " - Convergence process could not be finished within the given maximum iteration.\n";
		msg += " - Warning occurs in program Simpson::run.\n";
		msg += "+STATUS\n";
		msg += " - Reached tolerance value is " + str_tol + " against " + str_Tol + " target.\n";
		msg += "+INPUT DATA\n";
		msg += " - 1) Coordinates    -> ( " + str_xxx + ", " +str_yyy + ", " + str_zzz + ") (m).\n";
		msg += " - 2) Wind Direction -> ( " + str_wdr + ") (deg) : Clockwise from the north.\n";
		msg += " - 3) Wind Speed     -> ( " + str_wsp + ") (m/s)\n";
		msg += " - 4) Stability      -> ( " + str_stb + ") (1->A,2->B,3->C,4->D,5->E,6->F).\n";
		msg += "+RESOLUTIONS\n";
		msg += " - Incrementing the maximum iteration number or relaxing the tolerance value is an easy way.\n";
		msg += " - Such a resolution however could significantly make slow down process speed or inaccurate results.\n";
		msg += " - Generaly speaking some trials will be required for finding the best iteration-tolerance combinations\n";
		msg += " - depending on each project case.\n\n";
		msg += "...Process continued ...\n\n";
	}

	if(message_counter_ErrorSimpson == MAX_WARNING_MESSAGE)
	{
		msg += "Further warning messages will be suppressed ...\n\n";
	}

	return msg;
}

string ErrorTerrainAdjustment_simpl::message() const
{
	message_counter_ErrorTerrainAdjustment_simpl++;

	string msg = "";

	if(message_counter_ErrorTerrainAdjustment_simpl <= MAX_WARNING_MESSAGE)
	{

		char buffer[50];
		_itoa(i_d, buffer, 10); string str_i_d = buffer;
		_gcvt(x_x, 8,  buffer); string str_x_x = buffer;
		_gcvt(y_y, 8,  buffer); string str_y_y = buffer;
		_gcvt(e_x, 8,  buffer); string str_e_x = buffer;

		msg += "\n";
		msg += "+WARNING MESSAGE\n";
		msg += " - Generally the simple terrain adjustment scheme should be applied when the terrain height\n";
		msg += " - at the receptor is less than the physical release height.\n";
		msg += " - Following USEPA recommendation, the receptor height has been chopped off at the physical\n";
		msg += " - release height by the software.\n";
		msg += "+STATUS\n";
		msg += " - The simple terrain condition was violated.\n";
		msg += "+INPUT DATA\n";
		msg += " - 1) Stack Id                -> ( " + str_i_d + ").\n";
		msg += " - 2) Receptor Coordinates    -> ( " + str_x_x + ", " + str_y_y + ") (m).\n";
		msg += " - 3) Excess Value(=z-zs-hs)  -> ( " + str_e_x + ") (m).\n";
		msg += "+RESOLUTIONS\n";
		msg += " - Restrict the computation domain that contains the simple terrain only.\n\n";
		msg += "...Process continued ...\n\n";
	}

	if(message_counter_ErrorTerrainAdjustment_simpl == MAX_WARNING_MESSAGE)
	{
		msg += "Further warning messages will be suppressed ...\n\n";
	}

	return msg;
}
