#ifndef NR_H
#define NR_H

#include <math.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>

class NR
{
public:
	class SpecialFunctions
	{
	public:
		static double gammln(double xx);										// ln(gamma(x)) for x > 0
		static double beta  (double z, double w);								// B(z; w)
		static void   gser  (double *gamser, double a, double x, double *gln);
		static void   gcf   (double *gammcf, double a, double x, double *gln);
		static double gammq (double a, double x);								// Incomplete gamma function Q(a; x)
		static double gammp (double a, double x);								// Incomplete gamma function P(a; x)
		static double erff  (double x);											// Error function erf(x).
		static double erffc (double x);											// Complementary error function erfc(x)
		static double erfcc (double x);											// Complementary error function erfc(x)
	
																				// Chebyshev evaluation
		static double chebev(double a, double b, double c[], int m, double x);
																				// Chebyshev expansion 
		static void   beschb(double x, double *gam1, double *gam2, double *gampl, double *gammi);
																				// Modified Bessel functions for fractional order for xnu >= 0
		static void   bessik(double x, double xnu, double *ri, double *rk, double *rip, double *rkp);
																				// Modified Bessel functions for fractional order for general xnu
		static void   bessIK(double x, double xnu, double *ri, double *rk, double *rip, double *rkp);
	};
};

#endif
