#ifndef POINT_SRC_H
#define POINT_SRC_H

#include "src.h"
#include "ring.h"

class PointSrc : public Src
{
protected:
	Ring*    rin;

	bool*    stk;		// Stack Tip  flag
	bool*    plm;		// Plume rise flag

						//	Unit:
	double*  emi;		// 	Quant-unit/s
	double*  vel;		// 	m/s
	double*  gas;		// 	Nm^3/s
	double*  tpr;		// 	K
public:
	PointSrc()
	{
		setIsFile(FileList::fnPointSrc(FileList::IS, 1));
		setOsFile(FileList::fnPointSrc(FileList::OS, 1));
	}
	virtual double getPointSrc(Ring& rin_, bool& stk_, bool& plm_, double& emi_, double& vel_, double& gas_, double& tpr_) const;
	virtual void redim(int n);
	virtual void scan ();
	virtual void print();
	virtual void lists();
	virtual void advance();
	virtual void reverse();
	virtual ~PointSrc();
};

#endif