#include "version.h"
#include "ErrorHandler.h"
#include "SimulationFactory.h"


// Construct the log & err global file streams ...
ofstream CLOG("../tmp/simulator_log.txt", ios::out);
ofstream CERR("../tmp/simulator_err.txt", ios::out);
ofstream CLST("../tmp/simulator_lst.txt", ios::out);
// ofstream CCSV("../tmp/simulator_lst.csv", ios::out);

bool TRACE_Q;
bool VALIDATION_Q;

void getOpts(int argc, char* argv[], string& opt2, bool& is_time_series);

int main(int argc, char* argv[])
{
	clog << VERSION1 << endl;
	CLOG << VERSION1 << endl;
	CLST << VERSION2 << endl;

	bool is_time_series; string opt2;
	getOpts(argc, argv, opt2, is_time_series);

	SimulationFactory* device = new SimulationFactory(opt2, is_time_series);
	device->scan ();
	device->lists();
	device->loop ();
	device->dump ();
	delete  device;
	return 0;
}


void getOpts(int argc, char* argv[], string& opt2, bool& is_time_series)
{
	string opt1; const bool release = true;


	try{
		if(false){/* dummy */}
		else if(release && argc > 1)
		{
			if(argc != 3) throw 1;

			opt1 = (string) argv[1];
			opt2 = (string) argv[2];
		}
		else if(release)
		{
			ifstream is("../tmp/argument.in.csv");
			is.exceptions(ios_base::goodbit);
			is.exceptions(ios_base::badbit | ios_base::failbit);
			is >> opt1;
			is >> opt2;
			is.close();
		}
		else
		{
			// Using fixed command line options for debugging.
			opt1 = "-s";
			opt2 = "ln";
		}

		if(opt1 != "-t" && opt1 != "-s" && opt1 != "-T" && opt1 != "-S" && opt1 != "-V") throw 2;
		else if(opt1 == "-t")
		{
			is_time_series = true;

			TRACE_Q = false; VALIDATION_Q = false;

			CLST << endl;
			CLST << endl;
			CLST << "$ General informations $" << endl;
			CLST << "1) Average mode is LONG."  << endl;
		}
		else if(opt1 == "-T")
		{
			is_time_series = true;

			TRACE_Q = true; VALIDATION_Q = false;

			CLST << endl;
			CLST << endl;
			CLST << "$ General informations $" << endl;
			CLST << "1) Average mode is LONG."  << endl;
		}
		else if(opt1 == "-s")
		{
			is_time_series = false;

			TRACE_Q = false; VALIDATION_Q = false;

			CLST << endl;
			CLST << endl;
			CLST << "$ General informations $" << endl;
			CLST << "1) Average mode is SHORT." << endl;
		}
		else if(opt1 == "-S")
		{
			is_time_series = false;

			TRACE_Q = true; VALIDATION_Q = false;

			CLST << endl;
			CLST << endl;
			CLST << "$ General informations $" << endl;
			CLST << "1) Average mode is SHORT." << endl;
		}
		else if(opt1 == "-V")
		{
			is_time_series = false;

			TRACE_Q = false; VALIDATION_Q = true;

			CLST << endl;
			CLST << endl;
			CLST << "$ General informations $" << endl;
			CLST << "1) Average mode is SHORT." << endl;
		}
	}
	catch(int checkpoint)
	{
		switch(checkpoint)
		{
		case 1:
			cerr << ErrorMain_argc(argc - 1);
			CERR << ErrorMain_argc(argc - 1);
			break;
		case 2:
			cerr << ErrorMain_argv(opt1, opt2);
			CERR << ErrorMain_argv(opt1, opt2);
			break;
		}
		exit(1);
	}
	catch(...)
	{
		cerr << ErrorMain_argfile("argument.in.csv");
		CERR << ErrorMain_argfile("argument.in.csv");
		exit(1);
	}

	if(opt2 == "mt")
	{
		CLST << "2) Enhanced METI-LIS simulator invoked."  << endl;
	}
	else
	{
		CLST << "2) Line source simulator invoked." << endl;
	}
	CLST << endl;
}
