#ifndef MET_H
#define MET_H

#include "../share/SimpleIterator.h"
#include "../share/FileFactory.h"

class Met : public SimpleIterator, public FileManager
{
	double meters;
	double average_seconds;
	double power_average_seconds;
protected:
	double* wd;
	double* ws;
	int*    st;
	double* tp;
public:
	Met()
	{
		setIsFile(FileList::fnMet(FileList::IS, 1));
		setOsFile(FileList::fnMet(FileList::OS, 1));
	}
	virtual ~Met();
	void setMet(double  wd_, double  ws_, int  st_, double  tp_);
	void getMet(double& wd_, double& ws_, int& st_, double& tp_) const;
	virtual void setTime(int  yr_, int  mn_, int  dy_, int  hr_){}
	virtual void getTime(int& yr_, int& mn_, int& dy_, int& hr_) const {}
	void   setAnemometerHeight(double meters_){meters = meters_;}
	double getAnemometerHeight() const {return meters;}

	virtual void   setAverageSeconds(double average_seconds_) {average_seconds = average_seconds_;}
	virtual double getAverageSeconds()       const {return average_seconds;}
	virtual void   setPower4AverageSeconds(double power_average_seconds_) {power_average_seconds = power_average_seconds_;}
	virtual double getPower4AverageSeconds() const {return power_average_seconds;}

	// Tiny wind direction conversion tool.
	virtual double wdConverter(double wd_) const {return ((wd_ >= -1.0e-10 && wd_ < 9000) ? ((wd_ + 180) - floor((wd_ + 180)/360)*360) : wd_);}

	virtual void redim(int n);
	virtual void scan ();
	virtual void print();
	virtual void lists();
	virtual void advance();
	virtual void reverse();
};

#endif
