#include "simpson.h"
#include "ErrorHandler.h"
#include "../share/common.h"

double Simpson::run()
{
	ML_TRACE("Simpson::run");

	double _cur;
	double _prv;
	double _tol;

	try
	{
 		_prv = prv = -1.0e30;
 		for(int i = 1; i <= data->getMaximumIterations(); i++)
		{
			trapezoid(i);
			_cur = (4.0*cur - prv)/3.0;
			if(fabs(_cur - _prv) <= (data->getToleranceRatio())*(fabs(_prv) + fabs(_cur))*0.5 && i >= data->getMinimumIterations())
			{
				return _cur;
			}
			_tol = fabs(_cur - _prv)/(fabs(_prv) + fabs(_cur))*2.0;
			 prv =  cur;
			_prv = _cur;
		}

		throw ErrorSimpson(_tol, data);
	}
	catch(const ErrorHandler& /*e*/)
	{
		CLOG << ErrorSimpson(_tol, data, true); return _cur;
	}
}
